Builtin fn makes unnecessary copy of arg
Status: Closed Start date: 19 Apr 2015

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: enhancing/improving Estimated time: 0.75 hour

Target version: CoCoA-5.4.0 Spent time: 1.15 hour

Description

While testing/profiling IndetsIn (defined in BuiltinOneLiners.C) I noticed that the arg was copied by the fn, making it needlessly slow.

Investigate!

Related issues:

Related to CoCoALib - Feature #658: Indets actually in a poly (or vector or m... Closed 22 Jan 2015

Related to CoCoA-5 - Slug #31: theValue makes copy In Progress 15 Nov 2011

History

#1 - 19 Apr 2015 20:47 - John Abbott

I ran the following test:

f := x+y+z+1;

f99 := f^99; // this is slow (~10s on my machine)

t0 := CpuTime();

for i := 1 to 100 do

  NoPrint := IndetsIn(f99);

endfor;

println "Loop time: ", TimeFrom(t0);

This reports a loop time of almost 10s.    

An essentially identical test in CoCoALib is too fast to measure (less than 0.001s).

So the "overhead" is more than 99% -- wholly unacceptable!

#2 - 28 May 2021 15:31 - John Abbott

- Status changed from New to Closed

- Assignee set to John Abbott

- Target version changed from CoCoA-5.?.? to CoCoA-5.4.0

- % Done changed from 0 to 100

- Estimated time set to 0.75 h
Now it takes 0.001s.  No idea why it is fast now and not before.

Closing.

#3 - 28 May 2021 15:43 - Anna Maria Bigatti

John Abbott wrote:

Now it takes 0.001s.  No idea why it is fast now and not before.

 

I guess is was for the move constructor

    RingElem(RingElem&& copy); // move ctor

defined in ring.H

// Revision 1.63  2020/10/05 19:30:31  abbott

// Summary: Added move ctor
